#ifndef RC2_H
#define RC2_H

extern const unsigned char  permute[512];
extern const unsigned char  inverse[256];

extern void rc2_full_keyschedule(unsigned char key[128]);
extern int  rc2_trial_encrypt(unsigned short key[64], unsigned short *p,
    unsigned short *c);
extern void rc2_decrypt(unsigned short key[64], unsigned short *c,
    unsigned short *p);
extern void rc2_encrypt(unsigned short key[64], unsigned short *c,
    unsigned short *p);

#define rc2_partial_keyschedule(key) \
do { \
    (key)[0]   = permute[(key)[0]]; \
    (key)[127] = permute[(key)[122] + (key)[126]]; \
} while (0)

#endif	/* RC2_H */
